/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function () {
dojo.provide("jazz.app.ua.internal.HelpDOMNode");

dojo.require("dijit._Widget");

dojo.require("jazz.app.ua.internal.client");
dojo.require("jazz.app.ua.internal.util");

dojo.declare("jazz.app.ua.internal.HelpDOMNode", dijit._Widget, {
	constructor: function (args) {
		this.uaKey = args.uaKey;
	},
	postCreate: function () {
		if (this.uaKey) {
			var dfd = jazz.app.ua.internal.client.getTopicPrefix(this.uaKey);
			dfd.addCallback(dojo.hitch(this, function (prefix) {
				var dfd2 = jazz.app.ua.internal.client.getContent(this.uaKey);
				dfd2.addCallback(dojo.hitch(this, function (content) {
					var doc = dojox.xml.parser.parse(content);
					this.addContentSection(doc.getElementsByTagName("description"));
					this.addTopicsSection(doc.getElementsByTagName("topic"), prefix);
				}));
			}));			
		}
	},
	addContentSection: function(nodeArray) {
		for (var i=0; i < nodeArray.length; i++) {
			jazz.app.ua.internal.util.copyChildNodes(this.domNode, nodeArray[i]);
		}
	},
	addTopicsSection: function(nodeArray, prefix) {
		var topicsDiv = document.createElement("div");
		topicsDiv.style.paddingTop = "5px";
		for (var i=0; i < nodeArray.length; i++) {
			var div = document.createElement("div");
			var link = document.createElement("a");
			link.target = "_blank";
			for (var j=0; j < nodeArray[i].attributes.length; j++) {
				if (nodeArray[i].attributes[j].name == "label") {
					link.appendChild(document.createTextNode(nodeArray[i].attributes[j].value));
				} else if (nodeArray[i].attributes[j].name == "href") {
					link.href = prefix + nodeArray[i].attributes[j].value;
				}
			}					
			div.appendChild(link);
			topicsDiv.appendChild(div);
		}
		this.domNode.appendChild(topicsDiv);
	}
});
})();
